$MetadirectoryServicesEx = [System.Reflection.Assembly]::LoadFile('C:\Program Files\Microsoft Forefront Identity Manager\2010\Synchronization Service\Bin\Assemblies\Microsoft.MetadirectoryServicesEx.dll')

$PSTypeAccelerators = [Type]::GetType("System.Management.Automation.TypeAccelerators")

if ($PSTypeAccelerators::Get.MVEntry -eq $null) {
    # Import all public types from Microsoft.MetadirectoryServices (exclude interfaces)
	$MetadirectoryServicesEx.GetTypes() |? { $_.Namespace -eq 'Microsoft.MetadirectoryServices' -and $_.Name -notlike 'I*' } |% { $PSTypeAccelerators::Add($_.Name, $_.AssemblyQualifiedName) }

	# Helper types
	$PSTypeAccelerators::Add('ConfigParameters', [System.Collections.ObjectModel.KeyedCollection``2[[System.String, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089], [Microsoft.MetadirectoryServices.ConfigParameter, Microsoft.MetadirectoryServicesEx, Version=4.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35]]])
	$PSTypeAccelerators::Add('CSEntryChanges', [System.Collections.Generic.IList``1[[Microsoft.MetadirectoryServices.CSEntryChange, Microsoft.MetadirectoryServicesEx, Version=4.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35]]])
	$PSTypeAccelerators::Add('SecureString', [System.Security.SecureString])
}

# ResolveJoinSearch Expected Object Output
function New-ResolveJoinSearch {
    param(
        [int]    $imventry     = -1,
        [string] $MVObjectType = $null,
        [switch] $Success      = $false
    )
    
    end {
        New-Object PSObject | Select-Object @{Name='imventry';Expression={$imventry}},@{Name='MVObjectType';Expression={$MVObjectType}},@{Name='Result';Expression={$Success}}
    }
}

# ShouldProjectToMV Expected Object Output
function New-ShouldProjectToMV {
    param(
        [string] $MVObjectType = $null,
        [switch] $Success      = $false
    )
    
    end {
        New-Object PSObject | Select-Object @{Name='MVObjectType';Expression={$MVObjectType}},@{Name='Result';Expression={$Success}}
    }
}